VERSION 5.00
Begin VB.Form Mix2Dxb 
   Caption         =   "MixW to DxBase"
   ClientHeight    =   3120
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   3000
   LinkTopic       =   "Form1"
   ScaleHeight     =   3120
   ScaleWidth      =   3000
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox TextCommand 
      Height          =   375
      Left            =   1320
      LinkItem        =   "Command"
      LinkTopic       =   "MixW|QSO"
      TabIndex        =   12
      Text            =   "Command"
      Top             =   3240
      Width           =   1335
   End
   Begin VB.CommandButton CommandSend 
      Caption         =   "Send!"
      Height          =   375
      Left            =   720
      TabIndex        =   11
      Top             =   2640
      Width           =   1575
   End
   Begin VB.TextBox Sent 
      Height          =   375
      Left            =   240
      TabIndex        =   10
      Text            =   "Sent"
      Top             =   3720
      Width           =   2535
   End
   Begin VB.TextBox HisName 
      Height          =   375
      Left            =   1080
      LinkItem        =   "Name"
      LinkTopic       =   "MixW|QSO"
      TabIndex        =   4
      Text            =   "Name"
      Top             =   2160
      Width           =   1575
   End
   Begin VB.TextBox Freq 
      Height          =   375
      Left            =   1080
      LinkItem        =   "Khz"
      LinkTopic       =   "MixW|QSO"
      TabIndex        =   3
      Text            =   "14075"
      Top             =   1680
      Width           =   1575
   End
   Begin VB.TextBox RSTs 
      Height          =   375
      Left            =   1080
      LinkItem        =   "RstSnt"
      LinkTopic       =   "MixW|QSO"
      TabIndex        =   2
      Text            =   "RSTs"
      Top             =   1200
      Width           =   1575
   End
   Begin VB.TextBox RSTr 
      Height          =   375
      Left            =   1080
      LinkItem        =   "RstRcv"
      LinkTopic       =   "MixW|QSO"
      TabIndex        =   1
      Text            =   "RSTr"
      Top             =   720
      Width           =   1575
   End
   Begin VB.TextBox Callsign 
      Height          =   375
      Left            =   1080
      LinkItem        =   "Call"
      LinkTopic       =   "MixW|QSO"
      TabIndex        =   0
      Text            =   "Call"
      Top             =   240
      Width           =   1575
   End
   Begin VB.Label Label6 
      Caption         =   "Command"
      Height          =   255
      Left            =   240
      TabIndex        =   13
      Top             =   3240
      Width           =   855
   End
   Begin VB.Label Label5 
      Caption         =   "Name"
      Height          =   255
      Left            =   240
      TabIndex        =   9
      Top             =   2160
      Width           =   495
   End
   Begin VB.Label Label4 
      Caption         =   "KHz"
      Height          =   255
      Left            =   240
      TabIndex        =   8
      Top             =   1680
      Width           =   495
   End
   Begin VB.Label Label3 
      Caption         =   "RST snt"
      Height          =   255
      Left            =   240
      TabIndex        =   7
      Top             =   1200
      Width           =   735
   End
   Begin VB.Label Label2 
      Caption         =   "RST rcvd"
      Height          =   255
      Left            =   240
      TabIndex        =   6
      Top             =   720
      Width           =   855
   End
   Begin VB.Label Label1 
      Caption         =   "Callsign"
      Height          =   255
      Left            =   240
      TabIndex        =   5
      Top             =   360
      Width           =   615
   End
End
Attribute VB_Name = "Mix2Dxb"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' This program passes data from MixW 2 to DxBase logging software
' Sample Visual Basic code by Denis Nechitailov, UU9JDR
' Run DxBase and MixW 2, then run this program

' Knowledge base articles:
'
' Example of Client-Server DDE Between Visual Basic Applications
' Article ID: Q74861
'
' HOWTO: Pass String Data Between Applications Using SendMessage
' Article ID: Q176058


' COPYDATASTRUCT is needed to copy the data between applications
Private Type COPYDATASTRUCT
    dwData As Long
    cbData As Long
    lpData As Long
End Type

Private Const WM_COPYDATA = &H4A

'Private Const DxBase$ = "DXbase"  ' DxBase window name
Private Const DxBase$ = "DXbase 2002"  ' DxBase window name (DXbase 2002)

' Declare DLL functions
Private Declare Function FindWindow Lib "user32" Alias _
    "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName _
    As String) As Long

Private Declare Function SendMessage Lib "user32" Alias _
    "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal _
    wParam As Long, lParam As Any) As Long

'Copies a block of memory from one location to another.
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" _
         (hpvDest As Any, hpvSource As Any, ByVal cbCopy As Long)

Sub Form_Load()

    ' Check if DxBase is loaded
    If FindWindow(vbNullString, DxBase) = 0 Then NoDxBase

    ' Set LinkMode and initial text
    
    On Error GoTo NoDde ' Exit the program if MixW is not loaded
    
    Callsign.Text = "Call"
    Callsign.LinkMode = vbLinkAutomatic
    
    RSTr.Text = "RST rcv"
    RSTr.LinkMode = vbLinkAutomatic
    
    RSTs.Text = "RST snt"
    RSTs.LinkMode = vbLinkAutomatic
    
    Freq.Text = "Frequency"
    Freq.LinkMode = vbLinkAutomatic
    
    HisName.Text = "Name"
    HisName.LinkMode = vbLinkAutomatic
    
    TextCommand.Text = "Command"
    TextCommand.LinkMode = vbLinkAutomatic
    
    Exit Sub
          
NoDde:
    MsgBox "MixW 2 is not loaded! The program will now exit."
    End ' Exit the program
          
End Sub
   
' No DxBase alert function
Private Sub NoDxBase()
    MsgBox "DxBase is not loaded! The program will now exit."
    End ' Exit the program
End Sub


Private Sub CommandSend_Click()

    ' Construct DxBase string

    Dx$ = Callsign.Text + "#" + RSTr.Text + "#" + RSTs.Text + "#" + Freq.Text + "#" + HisName.Text + "##"

    Sent.Text = Dx$
    
    ' Copy the string to DxBase

    Dim cds As COPYDATASTRUCT
    Dim ThWnd As Long
    Dim buf(1 To 1000) As Byte

    ' Get the hWnd of the target application
    ThWnd = FindWindow(vbNullString, DxBase$)
    If ThWnd = 0 Then NoDxBase ' Check if it's loaded
    
    ' Copy the string into a byte array, converting it to ASCII
    Call CopyMemory(buf(1), ByVal Dx$, Len(Dx$))
    cds.dwData = 10001 ' fixed value ( always use this for DXbase )
    cds.cbData = Len(Dx$)
    cds.lpData = VarPtr(buf(1))
    i = SendMessage(ThWnd, WM_COPYDATA, Me.hwnd, cds)

End Sub

Private Sub TextCommand_Change()

' Write the data if WRITE key was pressed
If TextCommand = "WRITE" Then Call CommandSend_Click
If TextCommand = "Save" Then Call CommandSend_Click

End Sub

